"{ Package: 'stx:goodies/ston/tests' }"

"{ NameSpace: Smalltalk }"

Object subclass:#STONTestDomainObject
	instanceVariableNames:'created modified integer float description color tags bytes
		boolean'
	classVariableNames:''
	poolDictionaries:''
	category:'STON-Tests-Support'
!

!STONTestDomainObject class methodsFor:'instance creation'!

dummy
	^ self new
		integer: 999999 atRandom;
		float: 999 atRandom / Float pi;
		boolean: #(true false) atRandom;
		bytes: (ByteArray streamContents: [ :out | 32 timesRepeat: [ out nextPut: 255 atRandom ] ]);
		description: (String streamContents: [ :out | 16 atRandom timesRepeat: [ out nextPutAll: 'Blah' ] ]);
		color: #(#red #green #blue) atRandom;
		tags: (Array 
			with: #(#one #two #three) atRandom
 			with: #(#alpha #beta #gamma) atRandom 
			with: #(#low #medium #high) atRandom);
		yourself
! !

!STONTestDomainObject class methodsFor:'ston-core'!

stonName
	^ #TestDomainObject
! !

!STONTestDomainObject methodsFor:'accessing'!

boolean
	^ boolean
!

boolean: anObject
	boolean := anObject
!

bytes
	^ bytes
!

bytes: anObject
	bytes := anObject
!

color
	^ color
!

color: anObject
	color := anObject
!

created
	^ created
!

created: anObject
	created := anObject
!

description
	^ description
!

description: anObject
	description := anObject
!

float
	^ float
!

float: anObject
	float := anObject
!

integer
	^ integer
!

integer: anObject
	integer := anObject
!

modified
	^ modified
!

modified: anObject
	modified := anObject
!

tags
	^ tags
!

tags: anObject
	tags := anObject
! !

!STONTestDomainObject methodsFor:'comparing'!

= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ color = anObject color
		and: [ 
			modified = anObject modified
				and: [ 
					created = anObject created
						and: [ 
							description = anObject description
								and: [ 
									boolean = anObject boolean
										and: [ 
											(float closeTo: anObject float) 		"Use #closeTo: instead of #= to increase portability"
												and: [ 
													bytes = anObject bytes 
														and: [ 
															integer = anObject integer 
																and: [ tags = anObject tags ] ] ] ] ] ] ] ]
!

hash
	"Answer an integer value that is related to the identity of the receiver."

	^ color hash
		bitXor:
			(modified hash
				bitXor:
					(created hash
						bitXor:
							(description hash
								bitXor: (boolean hash bitXor: (float hash bitXor: (bytes hash bitXor: (integer hash bitXor: tags hash)))))))
! !

!STONTestDomainObject methodsFor:'initialize-release'!

initialize
	created := modified := DateAndTime now.
! !

