"{ Package: 'stx:goodies/ston/tests' }"

"{ NameSpace: Smalltalk }"

Object subclass:#STONTestKnownObject
	instanceVariableNames:'id description'
	classVariableNames:'KnownObjects'
	poolDictionaries:''
	category:'STON-Tests-Support'
!


!STONTestKnownObject class methodsFor:'instance creation'!

fromId: idString
	"Given id, return a matching instance of me, either by returning an existing known instance or by creating a new one (that is automtically added to the known instances)"
	
	| uuid |
	uuid := UUID fromString: idString.
	^ self knownObjects 
		detect: [ :each | each id = uuid ] 
		ifNone: [ self new id: uuid ]
! !

!STONTestKnownObject class methodsFor:'acccessing'!

addKnownObject: object
	^ self knownObjects addIfNotPresent: object
!

knownObjects
	^ KnownObjects ifNil: [ KnownObjects := OrderedCollection new ]
!

resetKnownObjects
	KnownObjects ifNotNil: [ :collection | collection removeAll ]
! !

!STONTestKnownObject class methodsFor:'ston-core'!

fromSton: stonReader
	^ self fromId: stonReader parseListSingleton
! !

!STONTestKnownObject methodsFor:'accessing'!

description
	^ description
!

id
	^ id
! !

!STONTestKnownObject methodsFor:'comparing'!

= object
	self class == object class ifFalse: [ ^ false ].
	^ self id = object id
!

hash
	^ self id hash
! !

!STONTestKnownObject methodsFor:'initalize'!

description: string
	description := string
!

id: uuid
	id := uuid.
	self description: 'I am a complex object known under the ID ', id asString, ' - I was created @ ', DateAndTime now asString
!

initialize
	super initialize.
	self id: UUID new.
	self class addKnownObject: self
! !

!STONTestKnownObject methodsFor:'printing'!

printOn: stream
	super printOn: stream.
	stream nextPut: $(; print: id; nextPut: $)
! !

!STONTestKnownObject methodsFor:'ston-core'!

stonOn: stonWriter
	"We only write out our id"
	
	stonWriter writeObject: self listSingleton: self id asString
! !

!STONTestKnownObject class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

