"{ Package: 'stx:goodies/ston/tests' }"

"{ NameSpace: Smalltalk }"

Object subclass:#STONTestUser
	instanceVariableNames:'username password enabled'
	classVariableNames:''
	poolDictionaries:''
	category:'STON-Tests-Support'
!

!STONTestUser class methodsFor:'instance creation'!

dummy
        "self dummy"
        
        | username password |
        username := String streamContents: [ :stream |
                stream print: 'user'; print: 999 atRandom; print: '@company'; print: 99 atRandom; print: '.com' ].
        password := String streamContents: [ :stream |
                stream print: 'secret'; print: 999 atRandom ].
        ^ self new
                username: username;
                password: password;
                yourself

    "Modified: / 04-06-2019 / 11:05:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

new
    "return an initialized instance"

    ^ self basicNew initialize.
! !

!STONTestUser class methodsFor:'ston-core'!

stonName
	^ #TestUser
! !

!STONTestUser methodsFor:'accessing'!

enabled
	^ enabled
!

enabled: anObject
	enabled := anObject
!

password
	^ password
!

password: anObject
	password := anObject
!

username
	^ username
!

username: anObject
	username := anObject
! !

!STONTestUser methodsFor:'comparing'!

= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ username = anObject username and: [ password = anObject password and: [ enabled = anObject enabled ] ]
!

hash
	"Answer an integer value that is related to the identity of the receiver."

	^ username hash bitXor: (password hash bitXor: enabled hash)
! !

!STONTestUser methodsFor:'initialize-release'!

initialize 
	super initialize.
	enabled := true
! !

